(new-package)
(load-package 'dynamic-externals)
(load-package 'reinitializers)
(open 'scheme-with-scsh)
(open 'srfi-13)
(open 'dynamic-externals)
(open 'external-calls)
(open 'configure)
(open 'signals)
(open 'reinitializers)
(run '(define (normalize-la-entry key val)
        (let ((left-quotes-rx (rx (: bos #\')))
              (right-quotes-rx (rx (: #\' eos)))
              (kill-matches (lambda (rx str)
                              (regexp-substitute/global #f rx str 'pre 'post))))
          (cons (string->symbol key)
                (kill-matches left-quotes-rx
                              (kill-matches right-quotes-rx val))))))
(run '(define add-la-entry
        (let ((splitter (infix-splitter (rx #\=)))
              (comment-rx (rx (: bos #\#))))
          (lambda (line alist)
            (cond ((and (not (regexp-search? comment-rx line))
                        (string-index line #\=))
                   (let ((lst (splitter line)))
                     (if (= 2 (length lst))
                         (cons (apply normalize-la-entry lst) alist)
                         (error "Could not read la entry" line list))))
                  (else alist))))))
(run '(define (read-libtool-la file-name)
        (call-with-input-file file-name
          (lambda (port)
            (let lp ((line (read-line port)) (alist '()))
              (if (eof-object? line)
                  alist
                  (lp (read-line port) (add-la-entry line alist))))))))
(run '(define (init-scx)
        (let* ((lib-dir (string-append "/usr/local/lib/scsh/0.6/scx-0.2/lib"
                                       "/"
                                       (host)))
               (la-file-name (string-append lib-dir "/libscx.la"))
               (initializer-name "scx_init_xlib"))
          (let ((la-alist (read-libtool-la la-file-name)))
            (cond ((assoc 'dlname la-alist)
                   =>
                   (lambda (p)
                     (let ((module-file (string-append lib-dir "/" (cdr p))))
                       (dynamic-load module-file)
                       (lookup-all-externals)
                       (call-external (get-external initializer-name)))))
                  (else
                   (error "Could not figure out libscx's name"
                          la-file-name)))))))
(run '(define scx-reinitializer
        (make-reinitializer init-scx)))
(run '(init-scx))
(config)
(load "/usr/local/lib/scsh/0.6/scx-0.2/scheme/xlib/xlib-interfaces.scm")
(load "/usr/local/lib/scsh/0.6/scx-0.2/scheme/xlib/xlib-packages.scm")
(load "/usr/local/lib/scsh/0.6/scx-0.2/scheme/libs/libs-interfaces.scm")
(load "/usr/local/lib/scsh/0.6/scx-0.2/scheme/libs/libs-packages.scm")
(user)
